
from telethon import TelegramClient, events
from telethon.errors.rpcerrorlist import AuthKeyError
from telethon.sync import TelegramClient as SyncTelegramClient
import json

api_id_gate = 29760088
api_hash_gate = "7cd2222e0629c770789f9c6cf280d051"

# api_id_bill = 26338039
# api_hash_bill = "09bcd8c34c696df21466303aa13c8913"


async def main():
    await get_one_client(message_file="anon_gate", api_id=api_id_gate, api_hash=api_hash_gate, dialog_ids_file="dialog_ids_gate")
    # await get_one_client(message_file="anon_bill", api_id=api_id_bill, api_hash=api_hash_bill, dialog_ids_file="dialog_ids_bill")


async def get_one_client(message_file, api_id, api_hash, dialog_ids_file):
    # 创建 Telethon 客户端对象并进行身份验证
    client = TelegramClient(message_file, api_id, api_hash, timeout=60)
    await client.start()
    dialog_ids = {}

    # 获取所有群组的 ID 和名称
    dialogs = await client.get_dialogs()
    arr_dialog = [dialog for dialog in dialogs]
    for dialog in arr_dialog:
        print(
            f"ID: {dialog.id},  Name: {dialog.name}, title: {dialog.title}, is_user: {dialog.is_user }, is_group: {dialog.is_group}, is_channel: {dialog.is_channel }")
        dialog_ids[dialog.id] = {
            "ID": dialog.id,
            "Name": dialog.name,
            "title": dialog.title,
            "is_user": dialog.is_user,
            "is_group": dialog.is_group,
            "is_channel": dialog.is_channel
        }
    with open(f"{dialog_ids_file}.json", 'w') as f:
        json.dump(dialog_ids, f, separators=(',', ':'), indent=4)
    # 断开连接
    await client.disconnect()


if __name__ == "__main__":
    # 运行主循环
    import asyncio
    loop = asyncio.get_event_loop()
    try:
        loop.run_until_complete(main())
    except Exception as e:
        print(f"An error occurred: {e}")
