
const web3 = require('@solana/web3.js');
const fs = require("fs-extra");
const BigNumber = require("bignumber.js");
const { Wallet } = require('@coral-xyz/anchor');
const Decimal = require('decimal.js');
const BN = require('bn.js');
const cron = require('node-cron');
const bs58 = require('bs58')
const raydium_sdk = require("@raydium-io/raydium-sdk");
const deepcopy = require('deepcopy');
const clear = require('clear');
const Config = require("./config")
const axios = require('axios');

let jsonInfo2PoolKeys = raydium_sdk.jsonInfo2PoolKeys;
let connection = new web3.Connection("https://solana-mainnet.g.alchemy.com/v2/WLI0ohbUlvbsJVmoIvB1wTSwUA8qP5qS");
let Keypair = web3.Keypair;
let PublicKey = web3.PublicKey;
let mywalletaddress = Config.mywalletaddress;
let walletPrivateKey = Config.mywalletPrivateKey;
let wallet = new Wallet(Keypair.fromSecretKey(Uint8Array.from(bs58.decode(walletPrivateKey))))
let walletKeyPair = Keypair.fromSecretKey(Uint8Array.from(bs58.decode(walletPrivateKey)));

let mybianwallet = "DKXPAXjwAm987UfuwiXNaYQ857r8fo7QwWSYq36Qi7oG"
let log = console.log;
console.log = function () {
    let args = Array.from(arguments);
    let log_prefix = new Date().toISOString();
    args.unshift(log_prefix + "");
    log.apply(console, args);
}
BigInt.prototype.toJSON = function () {
    return this.toString()
}
async function main() {

    let balance = await connection.getBalance(new PublicKey(mywalletaddress));
    console.log("balance=", balance)

    const transferTransaction = new web3.Transaction().add(
        web3.SystemProgram.transfer({
            fromPubkey: new web3.PublicKey(mywalletaddress),
            toPubkey: new web3.PublicKey(mybianwallet),
            lamports: balance - 5000,
        })
    );


    const signature = await web3.sendAndConfirmTransaction(
        connection,
        transferTransaction,
        [walletKeyPair],
    );
    console.log(signature)

}

main()