

import requests

import json
feishu_url = 'https://open.feishu.cn/open-apis/bot/v2/hook/a68cffbf-9104-427b-8e25-62dfaf363a47'



def send_feishu(obj_sendmsg):
    payload_message = {
        "msg_type": "post",
        "content": {
            "post": {
                "zh_cn": {
                    "title": obj_sendmsg["str_tokenaddress"],
                    "content": [
                        
                    ]
                }
            }
        }
    }

    headers = {
        "Content-Type": "application/json; charset=utf-8",
    }
    content = []

 
    content.append([{
        "tag": "text",
        'text':  obj_sendmsg['str_iso8601_date']
    } 
    ])

    content.append([
        {
        "tag": "text",
        'text': "price: " +  obj_sendmsg['str_now_price']  
        },
        {
        "tag": "text",
        'text': '   '
        } ,
        {
        "tag": "text",
        'text': 'holder: ' + obj_sendmsg["str_number_holders"]  
        }
    
    ])

    content.append([
        {
        "tag": "text",
        'text':  "5m: " + obj_sendmsg['str_last_5m_change'] + "%"
        },
        {
        "tag": "text",
        'text': '   '
        } ,
        {
        "tag": "text",
        'text': '1h: ' + obj_sendmsg["str_last_1h_change"] + "%"
        }
    
    ])

    content.append([{
        "tag": "text",
        "text": "---------------"
    }])
    content.append([{
        "tag": "a",
        "href": "https://gmgn.ai/sol/token/" + obj_sendmsg["str_tokenaddress"],
        "text": "GMGN  " + obj_sendmsg["str_tokenaddress"]
    }])


    content.append([{
        "tag": "at",
        "user_id": "all",
        "user_name": "allman"
    }])

    payload_message["content"]["post"]["zh_cn"]["content"] = content
    payload_message["content"] = json.dumps(payload_message["content"])

    payload_message = json.dumps(payload_message)
    response = requests.post(
        url=feishu_url, headers=headers, data=payload_message)
    response_json = response.json()
    print(response_json)


sendfeishu(
 
     {
"str_iso8601_date": "str_iso8601_date",
"str_tokenaddress":"str_tokenaddress",
"str_number_holders":"str_number_holders",
"str_last_5m_change":"str_last_5m_change",
"str_last_1h_change":"str_last_1h_change",
"str_now_price":"str_now_price"

}
 
)
 