import time
import asyncio
from telethon import TelegramClient, events
from telethon.errors.rpcerrorlist import AuthKeyError
from telethon.sync import TelegramClient as SyncTelegramClient
import json
import datetime
import signal
import sys
import math
from telethon.tl.types import MessageEntityTextUrl
from apscheduler.schedulers.background import BackgroundScheduler
from telethon.tl.types import PeerUser, PeerChat, PeerChannel
import os
import traceback
import re
from apscheduler.schedulers.asyncio import AsyncIOScheduler
from code.ignore_config import obj_dalaobuytokenscounts
from code.ignore_config import obj_dalaoAdd_onlysell
from code.ignore_config import obj_mine_gendan_profit_info
from code.ignore_config import arr_dalao_allowpump
from code.ignore_config import  mywalletaddress
old_print = print


def timestamped_print(*args, **kwargs):
    old_print(datetime.datetime.utcnow().replace(
        microsecond=0), *args, **kwargs)


print = timestamped_print
print('\n'*5)


def keep_alnum(string):
    return re.sub(r'[^a-zA-Z0-9\.\s:+-]', ' ', string)
 
def term_sig_handler(signum, frame):
    save_obj_pendingSellToken()
    # save_obj_unraydium_token()
    save_obj_firsellToken()
    save_obj_mine_gendan_profit_info()
    print(f'catched singal: {signum}')
    
    sys.exit()




def global_exception_hook(exc_type, exc_value, exc_traceback):
    print(f"Global exception: {exc_type.__name__} - {exc_value}")
    traceback.print_tb(exc_traceback)
    raise



api_id_gate = 29760088
api_hash_gate = "7cd2222e0629c770789f9c6cf280d051"

# ID: 6541198030,  Name: Fluxbot
api_id_bill = 26338039
api_hash_bill = "09bcd8c34c696df21466303aa13c8913"

Fluxbot_id = 6541198030
Sol_Trading_Bot_Europe_id = 7000042208
Sol_Trading_Bot_Americas_id = 7174198482
Sol_Trading_Bot_id = 6899553164
Sol_Trading_Bot_New_id=6556421217
arr_Sol_Trading_Bot_id = [Sol_Trading_Bot_Europe_id , Sol_Trading_Bot_Americas_id ,Sol_Trading_Bot_id,Sol_Trading_Bot_New_id ]
now_chat_id = arr_Sol_Trading_Bot_id[0]
now_chat_id_idx = 0
lastest_message_id = -1
client_gate = TelegramClient('anon_gate', api_id_gate, api_hash_gate)
client_gate.start()
# client_bill = TelegramClient('anon_bill', api_id_bill, api_hash_bill)
# client_bill.start()


# obj_unraydium_token={

# }
tempobj_mine_ready_swap_action={}

# is_swaping_mine  = False
# obj_mine_ready_swap_action  int (timestamp) --> obj
obj_mine_ready_swap_action={
# "time.time() timestamp":{
    # "timestamp":timestamp
    # "is_swaping":False,
#     "swap_type": "sell",
#      "send_counts":0,
#     "str_swap_token_address": "0x1234567890123456789012345678901234567890",
#     "str_dalao_address": "0x9876543210987654321098765432109876543210",
#     # 抓哟用于处理 dalao1 1token dalao2 100token ,如果dalao1 sell token 100% ,我不会卖出 。 因为总比列太低 不太行 很难处理 因为没有5%的 button
#     # "calute_judge_sellpercent":False,

#     "number_dalao_sell_token_percent": 80.54,
 
#     # "str_swap_action_command":"buy 0.2 sol",
#     #    "str_swap_action_command":"sell 100%",
#     #  "str_swap_action_command":"sell 50%",
#         "str_swap_action_command":"",
# }
}

# 
# 
# 
# 


# tempobj_mine_ready_swap_action={

# }

# arr_dalaotimestamp = list(tempobj_mine_ready_swap_action.keys())

# for str_dalaotimestamp in arr_dalaotimestamp:
#     obj_mine_ready_swap_action[int(str_dalaotimestamp)] = tempobj_mine_ready_swap_action[str_dalaotimestamp]

obj_pendingSellToken = {}
obj_firsellToken={}
 
async def  send_token_address_message(chat_id , str_swap_token_address):  
    print(f"enter send_token_address_message str_swap_token_address={str_swap_token_address}")      
    
    # await client_gate.send_message(Sol_Trading_Bot_Europe_id, str_swap_token_address)
    await client_gate.send_message(chat_id, str_swap_token_address)
    return
# flux 获取dlao swap info 保存进 obj_mine_ready_swap_action 
# 在一个定时器 的函数中 便利读取 obj_mine_ready_swap_action ，对每一个元素进行check 如果可以买卖则进行买卖
async def handle_mine_ready_swap_action(  obj_one_mine_ready_swap_action,dalao_timestamp):
    global now_chat_id
    global obj_mine_ready_swap_action
    now_time = int(time.time()*1000)

    str_swap_token_address = obj_one_mine_ready_swap_action["str_swap_token_address"]
    str_dalao_address = obj_one_mine_ready_swap_action["str_dalao_address"]

    if obj_one_mine_ready_swap_action["is_swaping"] == True:
        if now_time - obj_one_mine_ready_swap_action["swaping_time"] >=obj_one_mine_ready_swap_action["send_counts"]* 35*1000:
            print(f"dalao_timestamp={dalao_timestamp} str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} is_swaping_too_long del")
            del obj_mine_ready_swap_action[dalao_timestamp] 
        else:
            print(f"dalao_timestamp={dalao_timestamp} str_dalao_address={str_dalao_address}  str_swap_token_address={str_swap_token_address} is_swaping")
        return True
    obj_one_mine_ready_swap_action["is_swaping"] = True
    obj_one_mine_ready_swap_action["swaping_time"]  = now_time


    check_res = check_mine_ready_swap_action(obj_one_mine_ready_swap_action)
    if check_res == False:
        del obj_mine_ready_swap_action[dalao_timestamp]
        return False
    str_swap_action_command = set_swap_action_commmand(obj_one_mine_ready_swap_action)
    if str_swap_action_command is None:
        del obj_mine_ready_swap_action[dalao_timestamp]
        return False
    # 准备swap token 输入 发送 tokenaddress 的message
        # 实际代码 如果测试 需要暂时屏蔽 

    obj_one_mine_ready_swap_action["send_counts"]+=1
    obj_one_mine_ready_swap_action["send_time"] = int(time.time()*1000)
    await send_token_address_message(chat_id=now_chat_id,str_swap_token_address=str_swap_token_address)
    return True



def check_mine_ready_swap_action(obj_one_mine_ready_swap_action):
    print("enter check_mine_ready_swap_action=",obj_one_mine_ready_swap_action)
    swap_type = obj_one_mine_ready_swap_action["swap_type"]
    str_swap_token_address = obj_one_mine_ready_swap_action["str_swap_token_address"]
    str_dalao_address = obj_one_mine_ready_swap_action["str_dalao_address"]
    number_dalao_swap_token_amount = obj_one_mine_ready_swap_action["number_dalao_swap_token_amount"]
    global obj_firsellToken


    obj_pendingSellToken_value=obj_pendingSellToken.get(str_swap_token_address)
    if swap_type == "buy":
        # if obj_unraydium_token.get(str_swap_token_address) :
        #     print(
        #             f"PRINT NotBuyToken str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} token_not_raydum")
        #     # citoken为非raydium 直接pass
        #     return False
        
        if obj_firsellToken.get(str_swap_token_address) and str_dalao_address in  obj_firsellToken.get(str_swap_token_address) :
            print(f"PRINT NotBuyToken str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} dalao_swaptoken_issell")
            return False


        if (obj_dalaobuytokenscounts[str_dalao_address].get(str_swap_token_address) ) :
            # // obj_dalaobuytokenscounts 存在这个token信息，说明之前买过后来remove这个token了
            if (obj_dalaobuytokenscounts[str_dalao_address][str_swap_token_address]['buyCounts'] >=1) :
                print(f'PRINT NotBuyToken str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} exceed_buy_counts_limits')
                return False
            else :
                if  number_dalao_swap_token_amount  <= 0.07:
                    obj_dalaobuytokenscounts[str_dalao_address][str_swap_token_address]['buyCounts']+=0.5
                else:
                    obj_dalaobuytokenscounts[str_dalao_address][str_swap_token_address]['buyCounts']+=1
        else :
            if  number_dalao_swap_token_amount  <= 0.07:
                obj_dalaobuytokenscounts[str_dalao_address][str_swap_token_address] = { 'buyCounts': 0.5 }
            else:
                obj_dalaobuytokenscounts[str_dalao_address][str_swap_token_address] = { 'buyCounts': 1 }


        if (obj_pendingSellToken_value is None):
            obj_pendingSellToken[str_swap_token_address]= {
                "str_swap_token_address": str_swap_token_address,
                "number_total_mine_token_amount":0,
                "arr_dalao_address": [str_dalao_address],
                "arr_txHash": [],
                "obj_total_dalao_info": {}
            }

            obj_pendingSellToken_value = obj_pendingSellToken.get(
                str_swap_token_address)
            obj_pendingSellToken_value['obj_total_dalao_info'][str_dalao_address] = {
                "str_dalao_address": str_dalao_address,
                "str_swap_token_address": str_swap_token_address,
                "isSelling": False,
                "number_mine_main_token_amount": 0,
                "number_mine_token_amount": 0,
            }
            obj_dalao_info = obj_pendingSellToken_value['obj_total_dalao_info'][str_dalao_address]
        else:
            obj_dalao_info = obj_pendingSellToken_value['obj_total_dalao_info'].get(str_dalao_address)
            if obj_dalao_info is None:
                obj_pendingSellToken_value['obj_total_dalao_info'][str_dalao_address] = {
                    "str_dalao_address": str_dalao_address,
                    "str_swap_token_address": str_swap_token_address,
                    "isSelling": False,
                    "number_mine_main_token_amount": 0,
                    "number_mine_token_amount": 0,
                }
            obj_dalao_info = obj_pendingSellToken_value['obj_total_dalao_info'][str_dalao_address]

        if str_dalao_address not in obj_pendingSellToken_value['arr_dalao_address']:
            obj_pendingSellToken_value['arr_dalao_address'].append(str_dalao_address)

        # if len(obj_pendingSellToken_value['arr_dalao_address']) <= 1:
        #     print(
        #         f"PRINT NotBuyToken str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} Token第一次购买")
        #     # // 第一个dalao一直在买 次数置为1 为了以后其他dalao买了之后可以在买一次
        #     # obj_dalaobuytokenscounts[str_dalao_address][str_swap_token_address]['buyCounts'] = 1
        #     return False
        
        # if  number_dalao_swap_token_amount  <= 0.07:
        #     print(
        #         f"PRINT NotBuyToken str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} number_dalao_cost_sol_too_low")
        #     # // number_dalao_swap_token_amount<=0.07  次数置为0 为了以后 可以在买一次
        #     obj_dalaobuytokenscounts[str_dalao_address][str_swap_token_address]['buyCounts'] = 0 
        #     return False
        
    else:
  
        res = True
        
        if (obj_pendingSellToken_value is None):
            print(f'PRINT NotSell str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} no_the_token')
            res =False
            if obj_firsellToken.get(str_swap_token_address) is None :
                obj_firsellToken[str_swap_token_address]=[]
            obj_firsellToken[str_swap_token_address].append(str_dalao_address)
            return res
        
        number_total_mine_token_amount =  obj_pendingSellToken_value['number_total_mine_token_amount']
        if (number_total_mine_token_amount== 0) :
            print(f'PRINT NotSell str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} number_total_mine_token_amount=0')
            res =False
            # return False
        
        obj_dalao_info = obj_pendingSellToken_value['obj_total_dalao_info'].get(str_dalao_address)
        if (obj_dalao_info is None ) :
            print(f'PRINT NotSell str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} no_the_dalao')
            res =False
            if obj_firsellToken.get(str_swap_token_address) is None :
                obj_firsellToken[str_swap_token_address]=[]
            obj_firsellToken[str_swap_token_address].append(str_dalao_address)
            return res
         
        if (obj_dalao_info['number_mine_token_amount'] == 0) :
            print(f'PRINT NotSell str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} number_mine_token_amount=0')
            res =False
             
        return res

    return True

def set_swap_action_commmand(obj_one_mine_ready_swap_action):
    print("enter set_swap_action_commmand")
    swap_type = obj_one_mine_ready_swap_action["swap_type"]
    str_swap_token_address = obj_one_mine_ready_swap_action["str_swap_token_address"]
    str_dalao_address = obj_one_mine_ready_swap_action["str_dalao_address"]

    obj_one_mine_ready_swap_action["str_swap_action_command"] =None
    
    str_swap_action_command = None
     

    if swap_type == "buy":
        str_swap_action_command='buy 0.04 sol'
        obj_one_mine_ready_swap_action["str_swap_action_command"] =str_swap_action_command
    else:
        obj_pendingSellToken_value=obj_pendingSellToken.get(str_swap_token_address)
        number_total_mine_token_amount =  obj_pendingSellToken_value['number_total_mine_token_amount']
        obj_dalao_info = obj_pendingSellToken_value['obj_total_dalao_info'].get(str_dalao_address)
     
        number_dalao_sell_token_percent = obj_one_mine_ready_swap_action['number_dalao_sell_token_percent']
        number_mine_token_amount = obj_dalao_info['number_mine_token_amount']
        number_mine_sell_amount = number_dalao_sell_token_percent /100 * number_mine_token_amount  
        number_mine_sell_percent = number_mine_sell_amount / number_total_mine_token_amount*100
        if number_mine_sell_percent<20:
            str_swap_action_command=None
            # 不卖
        elif number_mine_sell_percent>=80:
            str_swap_action_command="sell 100"

        else:
            number_mine_sell_percent = int(math.floor(number_mine_sell_percent/10)*10)
            str_swap_action_command = f'sell {number_mine_sell_percent}%'
        obj_one_mine_ready_swap_action["str_swap_action_command"] =str_swap_action_command
    print(f"PRINT ready {swap_type} str_dalao_address={str_dalao_address}  str_swap_token_address={ str_swap_token_address} str_swap_action_command={str_swap_action_command}")
    return str_swap_action_command

def handle_swap_token_submit(swap_mode,message_text , str_swap_token_address,str_dalao_address):
    global obj_mine_ready_swap_action
    dalao_timestamp = min(list(obj_mine_ready_swap_action.keys()))
    obj_one_mine_ready_swap_action = obj_mine_ready_swap_action[dalao_timestamp]
    obj_one_mine_ready_swap_action["submit_time"] = int(time.time()*1000)
    return
def handle_swap_token_success(swap_mode,message_text , str_swap_token_address,str_dalao_address):
    # You bought 17235.087 SCOOT Ξ 0.1 SOL at transaction
    # You sold 17235.09 SCOOT Ξ 0.1 SOL Ξ $14.71 at transaction
    message_text = keep_alnum(string=message_text.strip().lower())
    message_text=message_text.strip()

    message_text=re.sub(r'\s+', ' ', message_text)
    message_text=message_text.split("at transaction")[0].strip()
    arr_message =message_text.split(' ')

    print(f"PRINT handle_swap_token_success_() str_dalao_address={str_dalao_address} str_swap_token_address={str_swap_token_address} swapinfo: {arr_message[1]} {arr_message[4]} {arr_message[5]}" )
    number_mine_eth = float(arr_message[4])  
    if  obj_mine_gendan_profit_info[str_dalao_address].get(str_swap_token_address) is None:
        obj_mine_gendan_profit_info[str_dalao_address][str_swap_token_address]={
            "firswap_time":int(time.time()),
            "dalao_url":f"https://dexscreener.com/solana/{str_swap_token_address}?maker={str_dalao_address}",
            "mine_url":f"https://dexscreener.com/solana/{str_swap_token_address}?maker={mywalletaddress }",
            "number_mine_cost_eth":0,
            "number_mine_earn_eth":0,
            "number_mine_profit":0
        }
    if obj_mine_gendan_profit_info[str_dalao_address].get(str_swap_token_address) is not None:
        if swap_mode=="buy":
            obj_mine_gendan_profit_info[str_dalao_address][str_swap_token_address]["number_mine_cost_eth"]+=number_mine_eth 
            obj_mine_gendan_profit_info[str_dalao_address][str_swap_token_address]["number_mine_profit"] -=number_mine_eth
        else:
            obj_mine_gendan_profit_info[str_dalao_address][str_swap_token_address]["number_mine_earn_eth"]+=number_mine_eth
            obj_mine_gendan_profit_info[str_dalao_address][str_swap_token_address]["number_mine_profit"] +=number_mine_eth
    
    number_mine_swap_token_amount = 0
    if swap_mode == "buy":
        number_mine_swap_token_amount = float(arr_message[2])
    else:
        number_mine_swap_token_amount = -float(arr_message[2])
    # 获取此token的pending 信息和token关于此dalao的信息
    obj_pendingSellToken_value=obj_pendingSellToken.get(str_swap_token_address)
    number_total_mine_token_amount =  obj_pendingSellToken_value['number_total_mine_token_amount']
    obj_dalao_info = obj_pendingSellToken_value['obj_total_dalao_info'].get(str_dalao_address)
    number_mine_token_amount = obj_dalao_info['number_mine_token_amount']
    number_total_mine_token_amount=number_total_mine_token_amount+number_mine_swap_token_amount 
    number_mine_token_amount =number_mine_token_amount + number_mine_swap_token_amount

    number_total_mine_token_amount=0 if number_total_mine_token_amount<0 else number_total_mine_token_amount
    number_mine_token_amount=0 if number_mine_token_amount<0 else number_mine_token_amount
    obj_pendingSellToken_value['number_total_mine_token_amount'] = number_total_mine_token_amount
    obj_dalao_info['number_mine_token_amount'] = number_mine_token_amount

    return
async def swap_token_click_button(event,arr_button,swap_mode):
    # 获取最早的 dalao_swap_info
    # 1. 如果希望的swap_mode 与当前swap_mode 不一样 切换当前swap_mode
    # 2. 点击button buy token sell token
    print(f"enter swap_token_click_button_()")

    global obj_mine_ready_swap_action
    if len(obj_mine_ready_swap_action.keys())==0:
        print("obj_mine_ready_swap_action len=0")
        return

    dalao_timestamp = min(list(obj_mine_ready_swap_action.keys()))
    obj_dalao_swap_info = obj_mine_ready_swap_action[dalao_timestamp]

    str_swap_token_address=  obj_dalao_swap_info['str_swap_token_address']
    str_dalao_address =  obj_dalao_swap_info['str_dalao_address']
    print(f"swap_token_click_button_() str_swap_token_address={str_swap_token_address} str_dalao_address={str_dalao_address}")
    button_click = None
    if obj_dalao_swap_info["swap_type"] != swap_mode :
        # if  obj_dalao_swap_info["swap_type"]=="sell":
        # 理论上是 当前是buy mode 实际dalao 要卖出
        # click sell button to switch swap_mode
        for button in arr_button:
            if 'sell mode' in button.text.lower():
                button_click = button
                break
            else :
                continue
    else:
        # 根据 dalao的信息 确定要 要买/卖多少 从而确定 button
        str_swap_action_command = obj_dalao_swap_info["str_swap_action_command"]
        for button in arr_button:
            if str_swap_action_command=="sell 100":
                # 指令有问题 有的是sell all 有的是 sell 100%
                if "sell 100" in button.text.lower() or "sell all" in button.text.lower():
                    button_click = button
                    break
                else :
                    continue
            else:
                if str_swap_action_command in button.text.lower():
                    button_click = button
                    break
                else :
                    continue

    # print("暂时不要click button_click=",button_click)
    # if button_click :
    #     print("暂时不要click button_click.text=",button_click.text.lower())
    # return
    print("click button_click.text=",button_click.text.lower())
    await button_click.click()
    
    return 

async def get_mine_swap_transaction_info(event,swap_mode,swap_res):
    print("enter get_mine_swap_transaction_info")
    global obj_mine_ready_swap_action
    global now_chat_id

    event_message = event.message
    message_text = event.message.message
    print(f"get_mine_swap_transaction_info() message_text={message_text}")
    # entities_MessageEntityTextUrl = event_message.get_entities_text(MessageEntityTextUrl)
    # print("entities_MessageEntityTextUrl=",entities_MessageEntityTextUrl,type(entities_MessageEntityTextUrl))
    # if not entities_MessageEntityTextUrl:
    #     return
    # for url_entity, inner_text in entities_MessageEntityTextUrl:
    #     url = url_entity.url
    #     if "https://solscan.io/tx/" in url:
    #         txhash = url.split('/')[-1]
    #     print(f"swap_mode={swap_mode} swap_res={swap_res} txhash={txhash}")
    #     break
    if len(obj_mine_ready_swap_action.keys())==0:
        return

    dalao_timestamp = min(list(obj_mine_ready_swap_action.keys()))
    obj_one_mine_ready_swap_action = obj_mine_ready_swap_action[dalao_timestamp]
    
    str_swap_token_address=  obj_one_mine_ready_swap_action['str_swap_token_address']
    str_dalao_address =  obj_one_mine_ready_swap_action['str_dalao_address']
    # if obj_one_mine_ready_swap_action['swap_type'] == "sell":
    if swap_res=="submitting":
        # 正在 提交 不用管了
        handle_swap_token_submit(swap_mode=swap_mode,message_text=message_text,str_swap_token_address=str_swap_token_address ,str_dalao_address=str_dalao_address )
        return
    elif swap_res=="success":
        # 成功了 记录在案
        handle_swap_token_success(swap_mode=swap_mode,message_text=message_text,str_swap_token_address=str_swap_token_address ,str_dalao_address=str_dalao_address )
        del obj_mine_ready_swap_action[dalao_timestamp]
        return
    elif swap_res=="fail" or swap_res== "unknown":
        if swap_mode=="buy":
            # 买入失败 不用管了 直接放弃
            del obj_mine_ready_swap_action[dalao_timestamp]
            return
        else:
            # 重新发送此token信息
            if obj_one_mine_ready_swap_action["send_counts"]>=2:
                del obj_mine_ready_swap_action[dalao_timestamp]
                return 
            else:
                obj_one_mine_ready_swap_action["send_counts"]+=1
                obj_one_mine_ready_swap_action["send_time"] = int(time.time()*1000)
                await send_token_address_message(chat_id=now_chat_id,str_swap_token_address=str_swap_token_address)
        
        return
    return 


@client_gate.on(events.NewMessage(chats=[Fluxbot_id], incoming=True))
async def handle_incoming_gate_Fluxbot(event):
    global obj_mine_ready_swap_action ,obj_dalaoAdd_onlysell

    event_message = event.message
    message_text = event.message.message
   
    print(
        f"gate handle_incoming_gate_Fluxbot NewMessage event_message=", event_message)
    # await asyncio.sleep(1)


   

    if "new copy trade" not in message_text.lower():
        return
    dalao_txhash = None
    entities_MessageEntityTextUrl = event_message.get_entities_text(MessageEntityTextUrl)
    # print("entities_MessageEntityTextUrl=",entities_MessageEntityTextUrl,type(entities_MessageEntityTextUrl))
    if not entities_MessageEntityTextUrl:
        return
    for url_entity, inner_text in entities_MessageEntityTextUrl:
        url = url_entity.url
        if "https://solscan.io/tx/" in url:
            dalao_txhash = url.split('/')[-1]
        print(f"gate handle_incoming_gate_Fluxbot NewMessage dalao_txhash={dalao_txhash}")
        break
     

    return
    message_text = keep_alnum(string=message_text.strip())
    message_text=message_text.strip()
    message_text=re.sub(r'\s+', ' ', message_text)
 

    Token_B =  message_text.split('Token B:')[-1].strip()
    message_text=message_text.split('Token B:')[0].strip()
    Token_A =  message_text.split('Token A:')[-1].strip()
    message_text=message_text.split('Token A:')[0].strip()
    # print(f"gate handle_incoming_gate_Fluxbot Token_B={Token_B} Token_A={Token_A}")
    # print(f"gate handle_incoming_gate_Fluxbot message_text=",message_text)
    swap_type = ""
    if Token_A=="So11111111111111111111111111111111111111112":
        str_swap_token_address = Token_B 
        swap_type = "buy"
    else :
        str_swap_token_address = Token_A
        swap_type = "sell"
    
    Trader =  message_text.split('Trader:')[-1].strip()
    if obj_dalaobuytokenscounts.get(Trader) is None:
        # 并未跟踪此大佬
        return  
    message_text=message_text.split('Trader:')[0].strip()
    # 获取 TOKEN / MAIN TOKEN Amount
    message_text=message_text.split('Value:')[0].strip()
    str_token_amount = message_text.split('Amount:')[-1].strip()
    arr_token_amount =str_token_amount.split(" ")
    number_token_amount = float(arr_token_amount[0].strip())
    number_token_percent = float(arr_token_amount[-1].strip())

    if obj_dalaoAdd_onlysell.get(Trader) and swap_type=="buy" :
        print(f"str_dalao_address={Trader} not_obj_dalao_swap_info_onlysell")
        return  

    print(f"gate handle_incoming_gate_Fluxbot Trader={Trader} str_swap_token_address={str_swap_token_address}")
    dalao_timestamp = int(time.time()*1000)
    obj_dalao_swap_info ={
        "dalao_timestamp":dalao_timestamp,
        "swap_type":swap_type,
        "is_swaping":False,
        "send_counts":0,
        "str_swap_token_address":str_swap_token_address,
        "str_dalao_address": Trader,
        "number_dalao_sell_token_percent": number_token_percent ,
        "number_dalao_swap_token_amount":number_token_amount,
        "str_swap_action_command":"",
        "swaping_time":0,
        "submit_time":0,
        "send_time":0,
        "snipe_couts":0,
        "now_price":0,
        "is_getting_price":False,
        "dalao_txhash":""

    }
    print("gate handle_incoming_gate_Fluxbot obj_dalao_swap_info=",obj_dalao_swap_info)
   
    # 测试中 暂时屏蔽 
    # int --> obj
    obj_mine_ready_swap_action[dalao_timestamp] =obj_dalao_swap_info
    # global tempobj_mine_ready_swap_action
    # tempobj_mine_ready_swap_action[dalao_timestamp] =obj_dalao_swap_info
    # await handle_mine_ready_swap_action(obj_one_mine_ready_swap_action=obj_dalao_swap_info ,dalao_timestamp=dalao_timestamp)


@client_gate.on(events.MessageEdited(chats=[Sol_Trading_Bot_Europe_id, Sol_Trading_Bot_Americas_id,Sol_Trading_Bot_id,Sol_Trading_Bot_New_id], incoming=True))
async def handle_incoming_gate_Sol_Trading_Bot_Europe_MessageEdited(event):

    # new message 只考虑5种 
    # 1.  
    # 2.  
    # 3.  
    event_message = event.message
    message_text = event.message.message
    print(
        "handle_incoming_gate_Sol_Trading_Bot_Europe @client_gate.on(events.MessageEdited event_message=",event_message)
    
    global lastest_message_id
    # async get_messages
    now_messsage_id = event.id
    if now_messsage_id != lastest_message_id:
        print(f"handle_incoming_gate_Sol_Trading_Bot_Europe_MessageEdited now_messsage_id={now_messsage_id}  lastest_message_id={lastest_message_id}")
        return

    if 'you bought' in message_text.lower():
        await get_mine_swap_transaction_info(event=event, swap_mode ="buy",swap_res = "success")
        return
    elif 'you sold' in message_text.lower():
        await get_mine_swap_transaction_info(event=event, swap_mode ="sell",swap_res = "success")
        return
    elif 'buy failed' in message_text.lower():
        await get_mine_swap_transaction_info(event=event, swap_mode ="buy",swap_res = "fail")
        return
    elif 'sell failed' in message_text.lower():
        await get_mine_swap_transaction_info(event=event, swap_mode ="sell",swap_res = "fail")
        return
    elif 'buy unknown status' in message_text.lower():
        await get_mine_swap_transaction_info(event=event, swap_mode ="buy",swap_res = "unknown")
        return
    elif 'sell unknown status' in message_text.lower():
        await get_mine_swap_transaction_info(event=event, swap_mode ="sell",swap_res = "unknown")
        # 重新sell
        return

    # Sell unknown status transaction
 
    buttons = event.message.buttons
    if not buttons:
        print("no buttons")
        return

    is_swap_button = False
    buy_button = None
    buttons = sum(buttons, [])
 
    for button in buttons:
        if  'sell 10%' in button.text.lower():
            is_swap_button = True
            # buy_button = button
            break
        else :
            continue
    if not is_swap_button:
        print("is_swap_button==false")
        return
    
    await swap_token_click_button(event=event,arr_button=buttons,swap_mode='sell')

 


@client_gate.on(events.NewMessage(chats=[Sol_Trading_Bot_Europe_id, Sol_Trading_Bot_Americas_id,Sol_Trading_Bot_id,Sol_Trading_Bot_New_id], incoming=True))
async def handle_incoming_gate_Sol_Trading_Bot_Europe_NewMessage(event):
    
    global now_chat_id ,now_chat_id_idx,lastest_message_id 
    # global now_chat_id_idx
    # new message 只考虑3种 
    # 1. event.message.message 不用关注内容  关注 event.message.buttons text 需要有 Buy Mode  Actions  🚀 Buy 0.2 SOL 等按钮
    # 2. event.message.message = 🟣 Submitting buy transaction | 💳 Wallet: Eqyo34w6UCEKMwNPcXdu8CC8c6zp1UrXkaALJByTJjXL
    # 3. event.message.message = 🟣 Submitting sell transaction | 💳 Wallet: Eqyo34w6UCEKMwNPcXdu8CC8c6zp1UrXkaALJByTJjXL
    event_message = event.message
    message_text = event.message.message
    user_id=event_message.chat_id

    lastest_message_id = event.id
    print(f"lastest_message_id={lastest_message_id}")
    print("enter handle_incoming_gate_Sol_Trading_Bot_Europe_NewMessage client_gate.on(events.NewMessage event_message=",event_message)

    dalao_timestamp = min(list(obj_mine_ready_swap_action.keys()))
    obj_one_mine_ready_swap_action = obj_mine_ready_swap_action[dalao_timestamp]
    str_swap_token_address=  obj_one_mine_ready_swap_action["str_swap_token_address"]
    str_dalao_address = obj_one_mine_ready_swap_action["str_dalao_address"]


    if "made requests too often" in message_text.lower():
        # 这个机器人暂时不能用  用其他的机器人
        print(f"user_id= {user_id} too often")
        now_chat_id_idx = (now_chat_id_idx+1)%len(arr_Sol_Trading_Bot_id)
        now_chat_id = arr_Sol_Trading_Bot_id[now_chat_id_idx]
        obj_one_mine_ready_swap_action["send_counts"] -=1
        obj_one_mine_ready_swap_action["send_time"] = int(time.time()*1000)
        await send_token_address_message(chat_id=now_chat_id ,str_swap_token_address=str_swap_token_address )
        return



    if 'submitting buy transaction' in message_text.lower():
        await get_mine_swap_transaction_info(event=event, swap_mode ="buy",swap_res="submitting")
        return
    elif 'submitting sell transaction' in message_text.lower():
        await get_mine_swap_transaction_info(event=event, swap_mode ="sell",swap_res="submitting")
        return

    buttons = event.message.buttons
    if not buttons:
        print("not buttons")
        return
    
    

    is_swap_button = False
    is_sniper_mode = False
    is_raydium =True
    buttons = sum(buttons, [])
 
    for button in buttons:
        if  'sniper mode' in button.text.lower() or 'sniper 0.2 sol' in button.text.lower():
            is_sniper_mode = True
            break
        if  'buy 0.2 sol' in button.text.lower()  :
            is_swap_button = True
            break
        else :
            continue


    if is_sniper_mode:
        print("is_sniper_mode")
        if obj_one_mine_ready_swap_action["snipe_couts"]>=2:
            print("snipe_couts_exceed_times")
            obj_mine_ready_swap_action.pop(dalao_timestamp,True) 
            return
        obj_one_mine_ready_swap_action["snipe_couts"] +=1
        await send_token_address_message(chat_id=now_chat_id,str_swap_token_address=str_swap_token_address)
        return

    if not is_swap_button:
        # print("handle_incoming_gate_Sol_Trading_Bot_Europe_NewMessage_() message_text=",message_text)
        print("no_swap_button")
        obj_mine_ready_swap_action.pop(dalao_timestamp,True) 
        return
    if "raydium" not in message_text.lower():
        is_raydium=False
    # if not is_raydium :
    #     if str_dalao_address in arr_dalao_allowpump:
    #         pass
    #     else:
    #         print(f"str_swap_token_address={str_swap_token_address} Exchange_not_raydium")
    #         # obj_unraydium_token[str_swap_token_address] = True
    #         obj_pendingSellToken.pop(str_swap_token_address,True) 
    #         obj_mine_ready_swap_action.pop(dalao_timestamp,True) 
    #         return

    # 准备swap 了 但在swap 之前 对于买入token的行为 先判断 当前价格 如果价格增加过大 不在买入 return

    

    message_text = message_text.replace('⌛' , 'pricechange:')  
    message_text = message_text.replace('✅' , 'yes')  
    message_text = message_text.replace('❌' , 'no')  
    message_text = keep_alnum(string=message_text.strip().lower())


    def check_now_token_price(message_text):
        if not "Price:" in message_text:
            return None
        arr_split_message_text = message_text.split("Price:")
        now_token_price = arr_split_message_text[1].strip().split(" ")[0]
        now_token_price = float(now_token_price)
        return  now_token_price
    # 准备swap 了 但在swap 之前 对于买入token的行为 先判断 当前价格 如果价格增加过大 不在买入 return
    if obj_one_mine_ready_swap_action["swap_type"]=="buy":
        now_token_price = check_now_token_price(message_text=message_text)
        if now_token_price is None:
            print("now_token_price is None")
            obj_mine_ready_swap_action.pop(dalao_timestamp,True)  
            return
        dalao_price = obj_one_mine_ready_swap_action["dalao_price"]
        if( now_token_price - dalao_price )/dalao_price >=0.12:
            print("now_token_price_is_too_big")
            return
        

    has_pricechange=True
    if is_raydium:
        # renounced  freeze pricechange这些参数只有 在raydium 才会有 pump没有
        # if "renounced: no" in message_text or "freeze revoked: no" in message_text:
        if   "freeze revoked: no" in message_text:
            print(f"str_swap_token_address={str_swap_token_address} renounced no")
            obj_mine_ready_swap_action.pop(dalao_timestamp,True) 
            return
        if "pricechange" not in message_text  :
            print(f"str_swap_token_address={str_swap_token_address} dont_has_pricechange")
            has_pricechange = False
      
    if has_pricechange:
        str_pricechange = message_text.split("pricechange:")[-1].split('\n')[0].strip()
        str_pricechange = re.sub(r'\s+', ' ', str_pricechange)
        number_5m = 0
        number_1h=0
        number_6h=0
        number_24h=0
        idx_pricechange = 0
        if "5m:" not in str_pricechange:
            idx_pricechange=1
        if "1h:" not in str_pricechange:
            idx_pricechange=2
        if "6h:" not in str_pricechange:
            idx_pricechange=3
        if "24h:" not in str_pricechange:
            idx_pricechange=4
        if idx_pricechange ==4:
            print("idx_pricechange=",idx_pricechange)
        #     return
        # arr_pricechange = str_pricechange.split(" ")
        # if  idx_pricechange==0:
        #     number_5m = float(arr_pricechange[1])
        #     number_1h = float(arr_pricechange[3])
        #     number_6h = float(arr_pricechange[5])
        #     number_24h = float(arr_pricechange[7])
        # elif  idx_pricechange==1:
        #     number_1h = float(arr_pricechange[1])
        #     number_6h = float(arr_pricechange[3])
        #     number_24h = float(arr_pricechange[5])
        # elif  idx_pricechange==2:
        #     number_6h = float(arr_pricechange[1])
        #     number_24h = float(arr_pricechange[3])
        # elif  idx_pricechange==3:
        #     number_24h = float(arr_pricechange[1])

 
    await swap_token_click_button(event=event,arr_button=buttons,swap_mode='buy')


obj_global_info ={
    "timedTasks_idx":0
}



sys.excepthook = global_exception_hook
signal.signal(signal.SIGTERM, term_sig_handler)
signal.signal(signal.SIGINT, term_sig_handler)
print(f"Listening for messages containing  in chats ichat names...")

async def handle_mine_ready_swap_action_timed():

    global obj_mine_ready_swap_action
    while True:
        if len(obj_mine_ready_swap_action.keys())==0:
            break
        dalao_timestamp = min(list(obj_mine_ready_swap_action.keys()))
        obj_dalao_swap_info = obj_mine_ready_swap_action[dalao_timestamp]
 
        handle_res = await handle_mine_ready_swap_action(obj_one_mine_ready_swap_action=obj_dalao_swap_info , dalao_timestamp=dalao_timestamp)
        if handle_res == True:
            break
        else :
            continue

    return


 
def save_obj_mine_gendan_profit_info():
    global obj_mine_gendan_profit_info
    with open("obj_mine_gendan_profit_info.json", mode='w') as f:
        json.dump(obj_mine_gendan_profit_info, f)
    print("save obj_mine_gendan_profit_info")

    return
def init_obj_mine_gendan_profit_info():
    global obj_mine_gendan_profit_info
    if not os.path.exists("obj_mine_gendan_profit_info.json"):
        print("init obj_mine_gendan_profit_info")
        return
    with open("obj_mine_gendan_profit_info.json", mode='r') as f:
        temp_obj_mine_gendan_profit_info= json.load( f)

    for str_dalaoaddress in temp_obj_mine_gendan_profit_info.keys():
         if obj_mine_gendan_profit_info.get(str_dalaoaddress) is not None:
             obj_mine_gendan_profit_info[str_dalaoaddress] = temp_obj_mine_gendan_profit_info[str_dalaoaddress]
             
    print("init obj_mine_gendan_profit_info")

    return
 


def save_obj_dalaobuytokenscounts():
    global obj_dalaobuytokenscounts
    with open("obj_dalaobuytokenscounts.json", mode='w') as f:
        json.dump(obj_dalaobuytokenscounts, f)
    print("save obj_dalaobuytokenscounts")

    return
def init_obj_dalaobuytokenscounts():
    global obj_dalaobuytokenscounts
    if not os.path.exists("obj_dalaobuytokenscounts.json"):
        print("init obj_dalaobuytokenscounts")
        return
    with open("obj_dalaobuytokenscounts.json", mode='r') as f:
        temp_obj_dalaobuytokenscounts= json.load( f)

    for str_dalaoaddress in temp_obj_dalaobuytokenscounts.keys():
        if obj_dalaobuytokenscounts.get(str_dalaoaddress) is not None:
            obj_dalaobuytokenscounts[str_dalaoaddress] = temp_obj_dalaobuytokenscounts[str_dalaoaddress]
             
    print("init obj_dalaobuytokenscounts")

    return
 



def save_obj_pendingSellToken():
    global obj_pendingSellToken
    with open("pendingSellToken.json", mode='w') as f:
        json.dump(obj_pendingSellToken, f)
    print("save pendingSellToken")

    return
def init_obj_pendingSellToken():
    global obj_pendingSellToken
    if not os.path.exists("pendingSellToken.json"):
        print("init pendingSellToken")
        return
    with open("pendingSellToken.json", mode='r') as f:
        obj_pendingSellToken= json.load( f)
    print("init pendingSellToken")

    return

# def save_obj_unraydium_token():
#     global obj_unraydium_token
#     with open("obj_unraydium_token.json", mode='w') as f:
#         json.dump(obj_unraydium_token, f)
#     print("save obj_unraydium_token")

#     return
# def init_obj_unraydium_token():
#     global obj_unraydium_token
#     if not os.path.exists("obj_unraydium_token.json"):
#         print("init obj_unraydium_token")
#         return
#     with open("obj_unraydium_token.json", mode='r') as f:
#         obj_unraydium_token= json.load( f)
#     print("init obj_unraydium_token")

#     return



def save_obj_firsellToken():
    global obj_firsellToken
    with open("obj_firsellToken.json", mode='w') as f:
        json.dump(obj_firsellToken, f)
    print("save obj_firsellToken")

    return
def init_obj_firsellToken():
    global obj_firsellToken
    if not os.path.exists("obj_firsellToken.json"):
        print("init obj_firsellToken")
        return
    with open("obj_firsellToken.json", mode='r') as f:
        obj_firsellToken= json.load( f)
    print("init obj_firsellToken")

    return


def send_WSOL_tokenaddress_message():
    return
def get_WSOL_price():
    return

def fortest_save_tempobj_mine_ready_swap_action():
    global tempobj_mine_ready_swap_action
    global obj_mine_ready_swap_action
    # with open("fortest_save_tempobj_mine_ready_swap_action.json", mode='w') as f:
    #     json.dump(tempobj_mine_ready_swap_action, f)
    with open("obj_mine_ready_swap_action.json", mode='w') as f:
        json.dump(obj_mine_ready_swap_action, f)
    print("save fortest_save_tempobj_mine_ready_swap_action")

    return

async def timedTasks():
    global obj_global_info
    obj_global_info["timedTasks_idx"]+=1
    cur_timedTasks_idx =obj_global_info["timedTasks_idx"] 
    if cur_timedTasks_idx <8:
        return
     
    if cur_timedTasks_idx%900 == 0:
        obj_global_info["timedTasks_idx"]=10
        save_obj_pendingSellToken()
        # save_obj_unraydium_token()
        save_obj_firsellToken()
        save_obj_dalaobuytokenscounts()
        save_obj_mine_gendan_profit_info()
        # fortest_save_tempobj_mine_ready_swap_action()
         
    await handle_mine_ready_swap_action_timed()
    return

init_obj_pendingSellToken()
# init_obj_unraydium_token()
init_obj_firsellToken()
init_obj_mine_gendan_profit_info()
init_obj_dalaobuytokenscounts()
# scheduler = BackgroundScheduler({'apscheduler.timezone': 'UTC'})
scheduler = AsyncIOScheduler({'apscheduler.timezone': 'UTC'})
scheduler.add_job(timedTasks, "interval", seconds=1)   
# scheduler.add_job(func=timedTasks, trigger="cron", seconds=10)   
# '*/1 * * * * *'

scheduler.start()
client_gate.run_until_disconnected()
asyncio.get_event_loop().run_forever()
# client_bill.run_until_disconnected()
